//---------------------------------------------------------------------------
#include <vcl\vcl.h>
#include <stdio.h>
#include <dir.h>
#include <dos.h>
#include <io.h>
#pragma hdrstop

#include "Control.h"
#include "MdiFrame.h"
//---------------------------------------------------------------------------
#pragma resource "*.dfm"
TControlForm *ControlForm;
//---------------------------------------------------------------------------
__fastcall TControlForm::TControlForm(TComponent* Owner)
	: TForm(Owner)
{
}
//---------------------------------------------------------------------------
void __fastcall TControlForm::FormShow(TObject *Sender)
{
	int done;
    int count;
    long size;
    struct ffblk ffb;
    AnsiString tempfile;

    UpDown1->Position = (short)FrameForm->RMaxUndoCount;

    tempfile = FrameForm->RTempDir + "\\*.*";
    count = 0;
    size = 0L;

    done = findfirst(tempfile.c_str(), &ffb,
     FA_ARCH | FA_RDONLY | FA_HIDDEN | FA_SYSTEM | FA_DIREC);

    while (!done) {
        if (!(ffb.ff_attrib & FA_DIREC)) {
        	count++;
        	size += ffb.ff_fsize;
        }

        done = findnext(&ffb);
    }

    Panel3->Caption = " " + IntToStr(count) + "";
    if (size == 1L)
        Panel4->Caption = " 1Byte";
    else if (size > 1L && size < 1024L)
    	Panel4->Caption = " " + IntToStr(size) + "Bytes";
    else
    	Panel4->Caption = " " + IntToStr(size / 1024) + "KB";

    penmode = (TPenMode)(FrameForm->RPenMode);

    switch (penmode) {
    	case	pmCopy:
    		RadioButton1->Checked = true;
        	break;
    	case	pmNop:
    		RadioButton2->Checked = true;
        	break;
    	case	pmBlack:
    		RadioButton3->Checked = true;
        	break;
    	case	pmWhite:
    		RadioButton4->Checked = true;
        	break;
    	case	pmNotCopy:
    		RadioButton5->Checked = true;
        	break;
    	case	pmNot:
    		RadioButton6->Checked = true;
        	break;
    	case	pmMerge:
    		RadioButton7->Checked = true;
        	break;
    	case	pmMask:
    		RadioButton8->Checked = true;
        	break;
    	case	pmXor:
    		RadioButton9->Checked = true;
        	break;
    	case	pmNotMerge:
    		RadioButton10->Checked = true;
        	break;
    	case	pmNotMask:
    		RadioButton11->Checked = true;
        	break;
    	case	pmNotXor:
    		RadioButton12->Checked = true;
        	break;
    	case	pmMergePenNot:
    		RadioButton13->Checked = true;
        	break;
    	case	pmMergeNotPen:
    		RadioButton14->Checked = true;
        	break;
    	case	pmMaskPenNot:
    		RadioButton15->Checked = true;
        	break;
    	case	pmMaskNotPen:
    		RadioButton16->Checked = true;
        	break;
		default:
        	RadioButton1->Checked = true;
        	break;
	}

    UpDown2->Position = (TPosition)(FrameForm->RVaguePaint);

    copymode = (long)(FrameForm->RCopyMode);

    switch (copymode) {
    	case	cmSrcCopy:
    		RadioButton17->Checked = true;
        	break;
    	case	cmPatCopy:
    		RadioButton18->Checked = true;
        	break;
    	case	cmBlackness:
    		RadioButton19->Checked = true;
        	break;
    	case	cmWhiteness:
    		RadioButton20->Checked = true;
        	break;
    	case	cmNotSrcCopy:
    		RadioButton21->Checked = true;
        	break;
    	case	cmDstInvert:
    		RadioButton22->Checked = true;
        	break;
    	case	cmMergeCopy:
    		RadioButton23->Checked = true;
        	break;
    	case	cmMergePaint:
    		RadioButton24->Checked = true;
        	break;
    	case	cmNotSrcErase:
    		RadioButton25->Checked = true;
        	break;
    	case	cmPatInvert:
    		RadioButton26->Checked = true;
        	break;
    	case	cmPatPaint:
    		RadioButton27->Checked = true;
        	break;
    	case	cmSrcAnd:
    		RadioButton28->Checked = true;
        	break;
    	case	cmSrcErase:
    		RadioButton29->Checked = true;
        	break;
    	case	cmSrcInvert:
    		RadioButton30->Checked = true;
        	break;
    	case	cmSrcPaint:
    		RadioButton31->Checked = true;
        	break;
		default:
        	RadioButton17->Checked = true;
        	break;
	}
}
//---------------------------------------------------------------------------
void __fastcall TControlForm::FormCloseQuery(TObject *Sender, bool &CanClose)
{
	if (ModalResult == mrOk) {
        if (UpDown1->Position != FrameForm->RMaxUndoCount) {
        	FrameForm->RMaxUndoCount = UpDown1->Position;
        	FrameForm->InitUndoData();
        	FrameForm->SpeedButton47->Enabled = false;
        }

        if (RadioButton1->Checked)
        	penmode = pmCopy;
        else if (RadioButton2->Checked)
        	penmode = pmNop;
        else if (RadioButton3->Checked)
        	penmode = pmBlack;
        else if (RadioButton4->Checked)
        	penmode = pmWhite;
        else if (RadioButton5->Checked)
        	penmode = pmNotCopy;
        else if (RadioButton6->Checked)
        	penmode = pmNot;
        else if (RadioButton7->Checked)
        	penmode = pmMerge;
        else if (RadioButton8->Checked)
        	penmode = pmMask;
        else if (RadioButton9->Checked)
        	penmode = pmXor;
        else if (RadioButton10->Checked)
        	penmode = pmNotMerge;
        else if (RadioButton11->Checked)
        	penmode = pmNotMask;
        else if (RadioButton12->Checked)
        	penmode = pmNotXor;
        else if (RadioButton13->Checked)
        	penmode = pmMergePenNot;
        else if (RadioButton14->Checked)
        	penmode = pmMergeNotPen;
        else if (RadioButton15->Checked)
        	penmode = pmMaskPenNot;
        else if (RadioButton16->Checked)
        	penmode = pmMaskNotPen;
        else
        	penmode =pmCopy;

        FrameForm->RPenMode = (int)penmode;

    	FrameForm->RVaguePaint = UpDown2->Position;

        if (RadioButton17->Checked)
        	copymode = cmSrcCopy;
        else if (RadioButton18->Checked)
        	copymode = cmPatCopy;
        else if (RadioButton19->Checked)
        	copymode = cmBlackness;
        else if (RadioButton20->Checked)
        	copymode = cmWhiteness;
        else if (RadioButton21->Checked)
        	copymode = cmNotSrcCopy;
        else if (RadioButton22->Checked)
        	copymode = cmDstInvert;
        else if (RadioButton23->Checked)
        	copymode = cmMergeCopy;
        else if (RadioButton24->Checked)
        	copymode = cmMergePaint;
        else if (RadioButton25->Checked)
        	copymode = cmNotSrcErase;
        else if (RadioButton26->Checked)
        	copymode = cmPatInvert;
        else if (RadioButton27->Checked)
        	copymode = cmPatPaint;
        else if (RadioButton28->Checked)
        	copymode = cmSrcAnd;
        else if (RadioButton29->Checked)
        	copymode = cmSrcErase;
        else if (RadioButton30->Checked)
        	copymode = cmSrcInvert;
        else if (RadioButton31->Checked)
        	copymode = cmSrcPaint;
        else
        	copymode = cmSrcCopy;

        FrameForm->RCopyMode = (int)copymode;
    }
}
//---------------------------------------------------------------------------
void __fastcall TControlForm::Button3Click(TObject *Sender)
{
	int done;
    int rc, count;
    struct ffblk ffb;
    AnsiString tempfile;

    tempfile = FrameForm->RTempDir + "\\*.*";
    FrameForm->InitUndoData();
    FrameForm->SpeedButton47->Enabled = false;
    count = 0;

    done = findfirst(tempfile.c_str(), &ffb,
     FA_ARCH | FA_RDONLY | FA_HIDDEN | FA_SYSTEM | FA_DIREC);

    while (!done) {
        tempfile = FrameForm->RTempDir + "\\" + ffb.ff_name;
    	rc = unlink(tempfile.c_str());
        if (rc == 0)
        	count++;

        done = findnext(&ffb);
    }

    ShowMessage(IntToStr(count) + " ̃t@C폜܂B");

    Panel3->Caption = " 0";
    Panel4->Caption = " 0KB";
}
//---------------------------------------------------------------------------
void __fastcall TControlForm::Button4Click(TObject *Sender)
{
	FrameForm->Opening(false);	
}
//---------------------------------------------------------------------------
