//---------------------------------------------------------------------------
#ifndef MdiListH
#define MdiListH
//---------------------------------------------------------------------------
#include <vcl\Classes.hpp>
#include <vcl\Controls.hpp>
#include <vcl\StdCtrls.hpp>
#include <vcl\Forms.hpp>
#include <vcl\ExtCtrls.hpp>
#include <vcl\Menus.hpp>
#include <vcl\Dialogs.hpp>
//---------------------------------------------------------------------------
class TListForm : public TForm
{
__published:	// IDE Ǘ̃R|[lg
	TImage *Image1;
	TPopupMenu *PopupMenu1;
	TMenuItem *Open1;
	TMenuItem *N1;
	TMenuItem *Preview1;
	TMenuItem *N2;
	TMenuItem *Clear1;
	TMenuItem *Escape1;
	TMenuItem *Delete1;
	TMenuItem *Rename1;
	TMenuItem *Copy1;
	TMenuItem *Move1;
	TMenuItem *Option1;
	TMenuItem *N3;
	TMenuItem *Savelist1;
	TMenuItem *N4;
	TMenuItem *Close1;
	TMenuItem *Size1;
	TMenuItem *Print1;
	TMenuItem *Print2;
	TMenuItem *Setup1;
	TMenuItem *Selectall1;
	TMenuItem *Revers1;
	TFontDialog *FontDialog1;
	TMenuItem *Comment1;
	TMenuItem *Font1;
	TMenuItem *Square1;
	TMenuItem *CopytoClipboard11;
	void __fastcall FormCreate(TObject *Sender);
	void __fastcall FormShow(TObject *Sender);
	void __fastcall FormCloseQuery(TObject *Sender, bool &CanClose);
	void __fastcall FormClose(TObject *Sender, TCloseAction &Action);
	void __fastcall Open1Click(TObject *Sender);
	void __fastcall Image1MouseDown(TObject *Sender, TMouseButton Button,
	TShiftState Shift, int X, int Y);
	void __fastcall FormActivate(TObject *Sender);
	void __fastcall Image1DblClick(TObject *Sender);
	void __fastcall Clear1Click(TObject *Sender);
	void __fastcall Escape1Click(TObject *Sender);
	void __fastcall Delete1Click(TObject *Sender);
	void __fastcall Rename1Click(TObject *Sender);
	void __fastcall Copy1Click(TObject *Sender);
	void __fastcall Move1Click(TObject *Sender);
	void __fastcall Savelist1Click(TObject *Sender);
	void __fastcall Close1Click(TObject *Sender);
	void __fastcall Size1Click(TObject *Sender);
	void __fastcall Preview1Click(TObject *Sender);
	
	void __fastcall Print2Click(TObject *Sender);
	void __fastcall Setup1Click(TObject *Sender);
	void __fastcall Selectall1Click(TObject *Sender);
	void __fastcall FormKeyDown(TObject *Sender, WORD &Key, TShiftState Shift);
	void __fastcall Revers1Click(TObject *Sender);
	
	
	void __fastcall Comment1Click(TObject *Sender);
	void __fastcall Font1Click(TObject *Sender);
	void __fastcall Square1Click(TObject *Sender);
	
	
	void __fastcall CopytoClipboard11Click(TObject *Sender);
	void __fastcall FormDeactivate(TObject *Sender);
private:	// [U[錾
public:		// [U[錾
	__fastcall TListForm(TComponent* Owner);
    void __fastcall GetListFiles(void);
    void __fastcall DispListFiles(void);
    void __fastcall DispListFiles2(void);
    int  __fastcall LoadFile(const AnsiString FileName, Graphics::TBitmap *Bitmap);
	void __fastcall MakeFace(void);
    void __fastcall DrawFace(int i, int Color);
    void __fastcall DrawFrame(int i, int Color);
    void __fastcall RemakeList(void);
    void __fastcall ClearFaces(void);
    void __fastcall RestoreFaces(void);
    void __fastcall DispSizes(void);
    AnsiString __fastcall LongToShort(const AnsiString PathName);
    int  ListSize;			// TlC̃TCY(50 - 5000)
    int  ListColumn;		// Psɕ\TlC̐
    int  ListCount;			// ListForm ɕ\t@C̑
    int  MaxImageWidth;		// TlC̍vőC[W(60 - 5010)
    int  Target;			// ݂̃^[Qbgt@C̃CfbNXԍ
    int  MouseTarget;		// }EX|C^_̉摜̃CfbNXԍ
    int  SelectCount;		// ݑIĂt@C̐
    AnsiString  ListDir;	// ^[QbgfBNg
    AnsiString  ListFilter;	// \t@C̎
    TStringList *ListFiles;	// t@C̃Xg
    TStringList *ListSizes;	// t@CTCỸXg
    TStringList *ListComments;	// Rg̃Xg
    TStringList *ListIndex;	// IĂt@Cׂ̃CfbNX
    Graphics::TBitmap *ListBitmap;	// TlCp̃rbg}bv
    TIcon *LIcon;			// ACR̃[hɎg
};
//---------------------------------------------------------------------------
#define ListSpace  5		// TlCƊOgƂ̊Ԋu
#define ListSpace2 20		// TlCƉgƂ̊Ԋu
#define FaceWidth  (ListSize + ListSpace * 2)			// Og̕
#define FaceHeight (ListSize + ListSpace + ListSpace2)	// Og̍
//---------------------------------------------------------------------------
extern TListForm *ListForm;
//---------------------------------------------------------------------------
#endif
