//---------------------------------------------------------------------------
#include <vcl\vcl.h>
#pragma hdrstop

#include "Bright.h"
#include "MdiFrame.h"
//---------------------------------------------------------------------------
#pragma resource "*.dfm"
TBrightForm *BrightForm;
//---------------------------------------------------------------------------
__fastcall TBrightForm::TBrightForm(TComponent* Owner)
	: TForm(Owner)
{
}
//---------------------------------------------------------------------------
void __fastcall TBrightForm::TrackBar1Change(TObject *Sender)
{
    if (Tag != 0)
    	return;

	Panel1->Caption = IntToStr(TrackBar1->Position);
}
//---------------------------------------------------------------------------
void __fastcall TBrightForm::FormShow(TObject *Sender)
{
	Tag = 1;
    if (Effect == 0) {			// Bright
    	TrackBar1->Max = 100;
        TrackBar1->Min = - 100;
        TrackBar1->Frequency = 5;
        TrackBar1->LineSize = 5;
        TrackBar1->PageSize = 10;
		TrackBar1->Position = FrameForm->RBright;
    	Panel1->Caption = IntToStr(FrameForm->RBright);
        Caption = "邳";
    }
    else if (Effect == 1) {		// Edge
    	TrackBar1->Max = 100;
        TrackBar1->Min = 0;
        TrackBar1->Frequency = 5;
        TrackBar1->LineSize = 5;
        TrackBar1->PageSize = 10;
		TrackBar1->Position = FrameForm->REdge;
    	Panel1->Caption = IntToStr(FrameForm->REdge);
        Caption = "ދ";
    }
    else if (Effect == 2) {		// Mosaic
    	TrackBar1->Max = 50;
        TrackBar1->Min = 2;
        TrackBar1->Frequency = 1;
        TrackBar1->LineSize = 1;
        TrackBar1->PageSize = 2;
		TrackBar1->Position = FrameForm->RMosaic;
    	Panel1->Caption = IntToStr(FrameForm->RMosaic);
        Caption = "ӻ޲";
    }
    else if (Effect == 3) {		// Median
    	TrackBar1->Max = 100;
        TrackBar1->Min = 0;
        TrackBar1->Frequency = 5;
        TrackBar1->LineSize = 5;
        TrackBar1->PageSize = 10;
		TrackBar1->Position = FrameForm->RMedian;
    	Panel1->Caption = IntToStr(FrameForm->RMedian);
        Caption = "ɲޏ";
    }
    else if (Effect == 4) {		// Posterisation
    	TrackBar1->Max = 7;
        TrackBar1->Min = 1;
        TrackBar1->Frequency = 1;
        TrackBar1->LineSize = 1;
        TrackBar1->PageSize = 1;
		TrackBar1->Position = FrameForm->RPoster;
    	Panel1->Caption = IntToStr(FrameForm->RPoster);
        Caption = "߽ؾް";
    }
    else if (Effect == 5) {		// Sobel
    	TrackBar1->Max = 100;
        TrackBar1->Min = 0;
        TrackBar1->Frequency = 5;
        TrackBar1->LineSize = 5;
        TrackBar1->PageSize = 10;
		TrackBar1->Position = FrameForm->RSobel;
    	Panel1->Caption = IntToStr(FrameForm->RSobel);
        Caption = "֊so";
    }
    else if (Effect == 6) {		// PaintSobel
    	TrackBar1->Max = 100;
        TrackBar1->Min = 0;
        TrackBar1->Frequency = 5;
        TrackBar1->LineSize = 5;
        TrackBar1->PageSize = 10;
		TrackBar1->Position = FrameForm->RPaintSobel;
    	Panel1->Caption = IntToStr(FrameForm->RPaintSobel);
        Caption = "֊s`";
    }

    Tag = 0;
}
//---------------------------------------------------------------------------
void __fastcall TBrightForm::FormCloseQuery(TObject *Sender, bool &CanClose)
{
    if (ModalResult == mrOk) {
        if (Effect == 0)			// Bright
			FrameForm->RBright = TrackBar1->Position;
        else if (Effect == 1)		// Edge
			FrameForm->REdge = TrackBar1->Position;
        else if (Effect == 2)		// Mosaic
			FrameForm->RMosaic = TrackBar1->Position;
        else if (Effect == 3)		// Median
			FrameForm->RMedian = TrackBar1->Position;
        else if (Effect == 4)		// Posterisation
			FrameForm->RPoster = TrackBar1->Position;
        else if (Effect == 5)		// Sobel
        	FrameForm->RSobel = TrackBar1->Position;
        else if (Effect == 6)		// PaintSobel
        	FrameForm->RPaintSobel = TrackBar1->Position;
    }
}
//---------------------------------------------------------------------------