/************************************************************
 *    hjS       Ver. 1.20                    *
 *                                                          *
 *           for C, C++                                     *
 *                                                          *
 *          <IMAGEKIT.H>                  ()j[g    *
 *                                                          *
 *   L̂ckk֐𗘗pƂ                       *
 *   {t@CCN[hĉD                   *
 ************************************************************/
#ifndef IMAGEKIT_INCLUDE
#define IMAGEKIT_INCLUDE

#ifdef __WIN32__
	#ifndef _WIN32
		#define _WIN32
	#endif
#endif

#ifdef _WIN32
	#define IMAGEKIT_API	APIENTRY
	#define FAR_PASCAL		APIENTRY
#else
	#define IMAGEKIT_API	CALLBACK _export
	#define FAR_PASCAL		FAR PASCAL
#endif

/**********************************************************************
 * R}hꗗ                                                       *
 **********************************************************************
 * ImgKitBit24To8() : F                                        *
 *                                                                    *
 *     FHANDLE Handle  - Ұް             *
 *           LPSTR  Title   - ޲۸ޯ              *
 *           LPSTR  Message - ޲۸ޯү            *
 *   ߂lFHANDLE         - V                          *
 *                                                                    *
 *   24ޯ߸ٲҰ(ٶװ)8ޯ߸ٲҰ(256F)ɌF            *
 *                                                                    *
 *   ΉC[W                                                 *
 *       QSrbgsNZitJ[j                             *
 **********************************************************************
 * ImgKitBit8To4() : F                                         *
 *                                                                    *
 *     FHANDLE Handle  - Ұް             *
 *           LPSTR  Title   - ޲۸ޯ              *
 *           LPSTR  Message - ޲۸ޯү            *
 *   ߂lFHANDLE         - V                          *
 *                                                                    *
 *   덷gU@ɂfBUŏ                                     *
 *   8ޯ߸ٲҰ(256F)4ޯ߸ٲҰ(16F)ɌF              *
 *                                                                    *
 *   ΉC[W                                                 *
 *       WrbgsNZiQTUFj                                 *
 **********************************************************************
 * ImgKitBmpFileSave() : t@Cۑ                                 *
 *                                                                    *
 *     FLPSTR FileName - ۑ̧ٖ                              *
 *           HANDLE Handle  - ۑҰް             *
 *           LPSTR Title    - ޲۸ޯ              *
 *           LPSTR Message  - ޲۸ޯү            *
 *           BOOL Comp      - k׸(0:Ȃ  1:L)                *
 *   ߂lFBOOL       - 0ȊO(TRUE)                             *
 *                     s - 0    (FALSE)                            *
 *                                                                    *
 *   ΉC[Wik̎j                                 *
 *       SrbgsNZi  PUFj                                 *
 *       WrbgsNZiQTUFj                                 *
 **********************************************************************
 * ImgKitBright() : PxieRGB̒lύXj                   *
 *                                                                    *
 *     FHANDLE Handle  - ۑҰް             *
 *           LPSTR  Title   - ޲۸ޯ              *
 *           LPSTR  Message - ޲۸ޯү            *
 *           DOUBLE Bright  - W                                    *
 *   ߂lFBOOL       - 0ȊO(TRUE)                             *
 *                     s - 0    (FALSE)                            *
 *                                                                    *
 *       y = x + (SQRT(x) - x) * Bright                               *
 *           x:̃sNZl                                         *
 *           y:VsNZl                                       *
 *                                                                    *
 *         x = 0.5 (255*0.5=127)̎                                  *
 *           Bright =  1̎Fy = 0.7 (255*0.7=178)                   *
 *           Bright =  0̎Fy = 0.5 (255*0.5=127)                   *
 *           Bright = -1̎Fy = 0.3 (255*0.3=76)                    *
 **********************************************************************
 * ImgKitColor24And8() : Q̃C[W̍                         *
 *                                                                    *
 *     FHANDLE Handle24 - Ұނ(24ޯ߸)    *
 *           HANDLE Handle8  - Ұނ(8ޯ߸ٸڰ)   *
 *           LPSTR  Title    - ޲۸ޯ             *
 *           LPSTR  Message  - ޲۸ޯү           *
 *   ߂lFHANDLE          - V                         *
 *                                                                    *
 *   I Handle24  Handle8 j                          *
 *                                                                    *
 *     ----------        ----------                                   *
 *     |  ----  |        |        |      ----                         *
 *     |  |  |  |      |        |  {  |  |                         *
 *     |  ----  |        |        |      ----                         *
 *     ----------        ----------                                   *
 *    V      Handle24     Handle8                        *
 *                                                                    *
 *     24ޯ߸       24ޯ߸   8ޯ߸                     *
 *     Ұ             Ұ         Ұ                          *
 *                                                                    *
 *   ΉC[W                                                 *
 *         WrbgsNZiQTUF,QTUKO[XP[j      *
 *       QSrbgsNZitJ[j                             *
 **********************************************************************
 * ImgKitColorReverse() : F̔]                                    *
 *                                                                    *
 *     FHANDLE Handle  - Ұް             *
 *           LPSTR Title    - ޲۸ޯ              *
 *           LPSTR Message  - ޲۸ޯү            *
 *   ߂lFBOOL       - 0ȊO(TRUE)                             *
 *                     s - 0    (FALSE)                            *
 **********************************************************************
 * ImgKitConvertColor() : C[W̐FύX                        *
 *                                                                    *
 *     FHANDLE Handle    - Ұް           *
 *           int    Pixeltype - ϊޯĶװ(1, 4, 8, 24)          *
 *           BOOL   FixedPale - TRUE :Œpbggp              *
 *                              FALSE:œKŒpbggp          *
 *                                 (Pixeltype=1̎Œpbggp)*
 *           BOOL   Dither    - TRUE -덷gU@ɂfBU̎gp    *
 *                              FALSE-fBUȂ                      *
 *           LPSTR  Title     - ޲۸ޯ            *
 *           LPSTR  Message   - ޲۸ޯү          *
 *   ߂lFBOOL         - 0ȊO(TRUE)                           *
 *                     s   - 0    (FALSE)                          *
 **********************************************************************
 * ImgKitCopy() : C[Wf[^̃Rs[                              *
 *                                                                    *
 *     FHANDLE Handle  - Rs[̏Ұް   *
 *           LPSTR Title    - ޲۸ޯ              *
 *           LPSTR Message  - ޲۸ޯү            *
 *   ߂lFHANDLE         - Rs[̐V                *
 **********************************************************************
 * ImgKitCut() : C[W̐؂菈                               *
 *                                                                    *
 *     FHANDLE Handle  - Ұް             *
 *           LPSTR Title    - ޲۸ޯ              *
 *           LPSTR Message  - ޲۸ޯү            *
 *   ߂lFBOOL       - 0ȊO(TRUE)                             *
 *                     s - 0    (FALSE)                            *
 *                                                                    *
 *                                                                    *
 *   @                                                         *
 *     iPj}EXłS_NbN                               *
 *     iQj'' - ŌɃNbN_LZ            *
 *     iRj'~'   - S_̎w菈LZ                  *
 *     iSj's'     - ؂菈̎s                          *
 *                                                                    *
 *     \ - ۂ̃TCYŕ\                                  *
 *                i\Ȃ̓XN[o[𑀍삵āj      *
 *                i\                                  j      *
 *     S̕\ - EChẼTCYɍ킹đŜ̃C[W        *
 *                \                                                *
 *                                                                    *
 *                                                                    *
 *   w肵`̈̃C[W؂D̎̈悪`̗l     *
 *   `łȂƂ́AAtBϊ{ċ`̈擾D     *
 *                                                                    *
 *               _____ (3)       ϊ̃C[W̃TCY           *
 *      (2) /----     |          }̗lȌ`̎w̎S_(1)(2)     *
 *        /            |         (3)(4)̒Ɏ܂`ƂȂD       *
 *      /               |                                             *
 * (1)-------------------  (4)                                        *
 **********************************************************************
 * ImgKitDisplay() : C[W̕\                               *
 *                                                                    *
 *     FHWND   hWnd    - \鳲޳                   *
 *           HANDLE Handle  - Ұް                     *
 *           BOOL   Stretch - \@                                *
 *                            TRUE :EChẼTCYɃrbg}bv*
 *                                  Xgb`                    *
 *                            FALSE:ʏ̏Ԃŕ\                  *
 *                            AEChẼTCYrbg}bv  *
 *                            傫͏kĕ\                *
 *   ߂lFBOOL       - 0ȊO(TRUE)                             *
 *                     s - 0    (FALSE)                            *
 **********************************************************************
 * ImgKitDisplayXY() : C[W̕\                             *
 *                                                                    *
 *     FHWND   hWnd    - \鳲޳                   *
 *           HANDLE Handle  - Ұް                     *
 *           int    Xstart  - \Jnʒu(߸ْP)                 *
 *           int    Ystart  -       V                                *
 *   ߂lFBOOL       - 0ȊO(TRUE)                             *
 *                     s - 0    (FALSE)                            *
 **********************************************************************
 * ImgKitDisplayHdc() : C[W̕\                            *
 *                                                                    *
 *     FHDC    hDC     - \鳲޳޲÷            *
 *           HANDLE Handle  - Ұް                     *
 *           int    Width   - \鳲޳̕(߸ْP)           *
 *           int    Height  - \鳲޳̍(߸ْP)         *
 *           BOOL   Stretch - \@                                *
 *                            TRUE :EChẼTCYɃrbg}bv*
 *                                  Xgb`                    *
 *                            FALSE:ʏ̏Ԃŕ\                  *
 *                            AEChẼTCYrbg}bv  *
 *                            傫͏kĕ\                *
 *   ߂lFBOOL       - 0ȊO(TRUE)                             *
 *                     s - 0    (FALSE)                            *
 **********************************************************************
 * ImgKitDisplayHdcXY() : C[W̕\                          *
 *                                                                    *
 *     FHDC    hDC     - \鳲޳޲÷            *
 *           HANDLE Handle  - Ұް                     *
 *           int    Xstart  - \Jnʒu(߸ْP)                 *
 *           int    Ystart  -       V                                *
 *   ߂lFBOOL       - 0ȊO(TRUE)                             *
 *                     s - 0    (FALSE)                            *
 **********************************************************************
 * ImgKitDisplayRGB() : C[W̕\(ޯװ̎w\)         *
 *                                                                    *
 *     FHWND   hWnd    - \鳲޳                   *
 *           HANDLE Handle  - Ұް                     *
 *           BOOL   Stretch - \@                                *
 *                            TRUE :EChẼTCYɃrbg}bv*
 *                                  Xgb`                    *
 *                            FALSE:ʏ̏Ԃŕ\                  *
 *                            AEChẼTCYrbg}bv  *
 *                            傫͏kĕ\                *
 *           int    Red     - obN̐(0-255)                       *
 *           int    Green   - obN̗(0-255)                       *
 *           int    Blue    - obN̐(0-255)                       *
 *           BOOL   Frame   - TRUE :C[W̉ɍg`          *
 *                            FALSE:C[W̉ɍg`Ȃ      *
 *   ߂lFBOOL       - 0ȊO(TRUE)                             *
 *                     s - 0    (FALSE)                            *
 **********************************************************************
 * ImgKitDisplayHdcRGB() : C[W̕\(ޯװ̎w\)      *
 *                                                                    *
 *     FHDC    hDC     - \鳲޳޲÷            *
 *           HANDLE Handle  - Ұް                     *
 *           int    Width   - \鳲޳̕(߸ْP)           *
 *           int    Height  - \鳲޳̍(߸ْP)         *
 *           BOOL   Stretch - \@                                *
 *                            TRUE :EChẼTCYɃrbg}bv*
 *                                  Xgb`                    *
 *                            FALSE:ʏ̏Ԃŕ\                  *
 *                            AEChẼTCYrbg}bv  *
 *                            傫͏kĕ\                *
 *           int    Red     - obN̐(0-255)                       *
 *           int    Green   - obN̗(0-255)                       *
 *           int    Blue    - obN̐(0-255)                       *
 *           BOOL   Frame   - TRUE :C[W̉ɍg`          *
 *                            FALSE:C[W̉ɍg`Ȃ      *
 *   ߂lFBOOL       - 0ȊO(TRUE)                             *
 *                     s - 0    (FALSE)                            *
 **********************************************************************
 * ImgKitEmboss() : G{Xi菈j                          *
 *                                                                    *
 *     FHANDLE Handle  - Ұް             *
 *           LPSTR Title    - ޲۸ޯ              *
 *           LPSTR Message  - ޲۸ޯү            *
 *   ߂lFBOOL       - 0ȊO(TRUE)                             *
 *                     s - 0    (FALSE)                            *
 *                                                                    *
 *   ΉC[W                                                 *
 *       WrbgsNZiQTUKO[XP[j                 *
 **********************************************************************
 * ImgKitFileLoad() : t@ČĂяo                              *
 *                                                                    *
 *     FLPSTR FileName - Ăяo̧ٖ                          *
 *           LPSTR Title    - ޲۸ޯ              *
 *           LPSTR Message  - ޲۸ޯү            *
 *   ߂lFHANDLE         - Ұނ                         *
 *                                                                    *
 *  t@C`𔻒făt@C[h                        *
 **********************************************************************
 * ImgKitFileType() : t@C̏̎擾                            *
 *                                                                    *
 *     FLPSTR       FileName - Ăяo̧ٖ                    *
 *           LPFILE_INFO FileType - 擾                      *
 *   ߂lFBOOL        - 0ȊO(TRUE)                            *
 *                     s  - 0    (FALSE)                           *
 **********************************************************************
 * ImgKitFilter() : tB^                                      *
 *                                                                    *
 *     FHANDLE Handle  - Ұް             *
 *           LPSTR  Title   - ޲۸ޯ              *
 *           LPSTR  Message - ޲۸ޯү            *
 *           int    Proc    -                                     *
 *                            0 : ۰̨߽(Ɛ̏)     *
 *                                 (Ɛ̂ڂ)       *
 *                            1 : ۰̨߽(̏)           *
 *                                 (̂ڂ)             *
 *                            2 : ۰̨߽(̏)           *
 *                                 (̂ڂ)             *
 *                            3 : ް̨                           *
 *                                 (Gbao)                   *
 *                            4 : ׼̨                         *
 *                                 (Gbao)                   *
 *   ߂lFBOOL     - 0ȊO(TRUE)                               *
 *                   s - 0    (FALSE)                              *
 *                                                                    *
 *   ΉC[W                                                 *
 *         WrbgsNZiQTUKO[XP[j               *
 *       QSrbgsNZitJ[j                             *
 **********************************************************************
 * ImgKitGetFromClipBrd() : Nbv{[hC[W荞      *
 *                                                                    *
 *     FHWND   hWnd    - ޳                             *
 *   ߂lFHANDLE         - Ұނ                         *
 **********************************************************************
 * ImgKitGifFileLoad() : fhe`̃t@ČĂяo               *
 *                                                                    *
 *     FLPSTR FileName - Ăяo̧ٖ                          *
 *           LPSTR Title    - ޲۸ޯ              *
 *           LPSTR Message  - ޲۸ޯү            *
 *           int   Page     - Ăяo߰ޔԍ(0n܂ԍ)      *
 *   ߂lFHANDLE         - Ұނ                         *
 *                                                                    *
 * ImgKitFileLoad()ł̓ǂݍ݂ł͕̃C[W鎞A           *
 * ŏ̃y[WiOy[Wj̓ǂݍ݂s                       *
 **********************************************************************
 * ImgKitGifFileSave() : fhe`Ńt@Cۑ                     *
 *                                                                    *
 *     FLPSTR  FileName - ۑ̧ٖ                             *
 *           HANDLE Handle   - ۑҰް            *
 *           LPSTR  Title    - ޲۸ޯ             *
 *           LPSTR  Message  - ޲۸ޯү           *
 *   ߂lFBOOL        - 0ȊO(TRUE)                            *
 *                     s  - 0    (FALSE)                           *
 *                                                                    *
 *   ΉC[W                                                 *
 *       PrbgsNZi    QFj                                 *
 *       SrbgsNZi  PUFj                                 *
 *       WrbgsNZiQTUFj                                 *
 **********************************************************************
 * ImgKitGifInterFileSave() : fhe(ڽ)`Ńt@Cۑ        *
 *                                                                    *
 *     FLPSTR  FileName - ۑ̧ٖ                             *
 *           HANDLE Handle   - ۑҰް            *
 *           LPSTR  Title    - ޲۸ޯ             *
 *           LPSTR  Message  - ޲۸ޯү           *
 *   ߂lFBOOL        - 0ȊO(TRUE)                            *
 *                     s  - 0    (FALSE)                           *
 *                                                                    *
 *   ΉC[W                                                 *
 *       PrbgsNZi    QFj                                 *
 *       SrbgsNZi  PUFj                                 *
 *       WrbgsNZiQTUFj                                 *
 **********************************************************************
 * ImgKitGifInterTrFileSave() : fhe(ڽ)`̧          *
 *                                                                    *
 *     FLPSTR  FileName - ۑ̧ٖ                             *
 *           HANDLE Handle   - ۑҰް            *
 *           WORD   Red      - ɂگ(0-255)               *
 *           WORD   Green    -                                      *
 *           WORD   Blue     -                                      *
 *           LPSTR  Title    - ޲۸ޯ             *
 *           LPSTR  Message  - ޲۸ޯү           *
 *   ߂lFBOOL        - 0ȊO(TRUE)                            *
 *                     s  - 0    (FALSE)                           *
 *                                                                    *
 *   ΉC[W                                                 *
 *       PrbgsNZi    QFj                                 *
 *       SrbgsNZi  PUFj                                 *
 *       WrbgsNZiQTUFj                                 *
 **********************************************************************
 * ImgKitGifTrFileSave() : fhe()`̧                     *
 *                                                                    *
 *     FLPSTR  FileName - ۑ̧ٖ                             *
 *           HANDLE Handle   - ۑҰް            *
 *           WORD   Red      - ɂگ(0-255)               *
 *           WORD   Green    -                                      *
 *           WORD   Blue     -                                      *
 *           LPSTR  Title    - ޲۸ޯ             *
 *           LPSTR  Message  - ޲۸ޯү           *
 *   ߂lFBOOL        - 0ȊO(TRUE)                            *
 *                     s  - 0    (FALSE)                           *
 *                                                                    *
 *   ΉC[W                                                 *
 *       PrbgsNZi    QFj                                 *
 *       SrbgsNZi  PUFj                                 *
 *       WrbgsNZiQTUFj                                 *
 **********************************************************************
 * ImgKitImageAdd() : Q̃C[W̍                            *
 *                                                                    *
 *     FHANDLE Handle1 - Ұނ                  *
 *           HANDLE Handle2 - Ұނ                    *
 *           int    x       - Handle2ĂHandle1̉߸ْl    *
 *           int    y       -                          c             *
 *           int    Red     - ]̐(0-255)                     *
 *           int    Green   - ]̗(0-255)                     *
 *           int    Blue    - ]̐(0-255)                     *
 *           LPSTR  Title   - ޲۸ޯ              *
 *           LPSTR  Message - ޲۸ޯү            *
 *   ߂lFHANDLE         - V(24ޯ߸ٲҰ)        *
 *                                                                    *
 *   I Handle1  Handle2 j                           *
 *                                                                    *
 *     ----------        ----------                                   *
 *     |  ----  |        |        |      ----                         *
 *     |  |  |  |      |        |  {  |  |                         *
 *     |  ----  |        |        |      ----                         *
 *     ----------        ----------                                   *
 *    V      Handle1      Handle2                        *
 *     24ޯ߸                                                    *
 *     Ұ                                                          *
 **********************************************************************
 * ImgKitImageInfo() : ݂̃C[W̎擾                       *
 *                                                                    *
 *     FHANDLE Handle          - Ұް     *
 *           LPIMAGE_INFO ImageInfo - 擾                    *
 *   ߂lFBOOL               - 0ȊO(TRUE)                     *
 *                             s - 0    (FALSE)                    *
 *                                                                    *
 *  LPIMAGE_INFO \                                               *
 *                                                                    *
 *        Width     : ̃sNZ                                  *
 *        Height    : c̃sNZ                                  *
 *        Pixeltype : sNZ^Cv                                  *
 *                       0 : ( 1ޯ)-Ql                        *
 *                       1 : ( 4ޯ)-PUFJ[                    *
 *                       2 : ( 4ޯ)-PUKO[                  *
 *                       3 : ( 8ޯ)-QTUFJ[                  *
 *                       4 : ( 8ޯ)-QTUKO[                *
 *                       5 : (24ޯ)-PUVOFtJ[          *
 *        WidthByte : ̃oCg                                    *
 *        ImageSize : C[WTCY                                  *
 **********************************************************************
 * ImgKitImageSize() : C[WTCY̕ύX                           *
 *                                                                    *
 *     FHANDLE Handle  - Ұް             *
 *           LPSTR  Title   - ޲۸ޯ              *
 *           LPSTR  Message - ޲۸ޯү            *
 *           int    Width   - V  (߸)                       *
 *           int    Height  - V(߸)                       *
 *   ߂lFHANDLE         - V                          *
 **********************************************************************
 * ImgKitJpegFileLoad() : iodft@ČĂяo                  *
 *                                                                    *
 *     FLPSTR FileName - Ăяo̧ٖ                          *
 *           LPSTR Title    - ޲۸ޯ              *
 *           LPSTR Message  - ޲۸ޯү            *
 *           int   JpgCol   - ̧ق̓ǂݍݐF̎w                  *
 *                           (0:ٶװ  1:ڰ)                    *
 *   ߂lFHANDLE         - Ұނ                         *
 *                                                                    *
 *   tJ[C[WO[XP[œǂݍގɎgp             *
 *   C[WO[XP[͖̎ܘ_O[XP[œǂ           *
 *   ImgKitFileLoad()łiodft@CĂяoƃtJ[       *
 *   tJ[œǍ                                               *
 **********************************************************************
 * ImgKitJpegFileSave() : iodf`Ńt@Cۑ                  *
 *                                                                    *
 *     FLPSTR  FileName - ۑ̧ٖ                             *
 *           HANDLE Handle   - ۑҰް            *
 *           LPSTR  Title    - ޲۸ޯ             *
 *           LPSTR  Message  - ޲۸ޯү           *
 *           int    Quality  - JPEGkiW(0`100 :50`75)   *
 *           int    JpgCol   - o̧(0:ٶװ  1:ڰ)          *
 *   ߂lFBOOL        - 0ȊO(TRUE)                            *
 *                     s  - 0    (FALSE)                           *
 *                                                                    *
 *   ΉC[W                                                 *
 *         WrbgsNZiQTUFKO[j                     *
 *       QSrbgsNZitJ[j                             *
 **********************************************************************
 * ImgKitMemFree() : C[Wf[^̃                     *
 *                                                                    *
 *     FHANDLE Handle  - Ұް                     *
 *   ߂lFBOOL       - 0ȊO(TRUE)                             *
 *                     s - 0    (FALSE)                            *
 **********************************************************************
 * ImgKitMemSize() : C[Wf[^̃TCY擾               *
 *                                                                    *
 *     FHANDLE Handle   - Ұް                    *
 *   ߂lFDWORD           - ػ                                *
 **********************************************************************
 * ImgKitMosaic() : UCN                                      *
 *                                                                    *
 *     FHANDLE Handle  - Ұް             *
 *           LPSTR  Title   - ޲۸ޯ              *
 *           LPSTR  Message - ޲۸ޯү            *
 *           int    Rect    - ӻ޲߸ِ                        *
 *   ߂lFBOOL       - 0ȊO(TRUE)                             *
 *                     s - 0    (FALSE)                            *
 **********************************************************************
 * ImgKitPrint() :                                            *
 *                                                                    *
 *     FHWND   hWnd      - ޳                           *
 *           HDC    hDC       - ޲÷                   *
 *           HANDLE Handle    - Ұް           *
 *           LPRECT PrintRect - ͈̔                            *
 *           BOOL   Frame     - 0ȊO-g̈  0-g̈Ȃ    *
 *   ߂lFBOOL         - 0ȊO(TRUE)                           *
 *                     s   - 0    (FALSE)                          *
 **********************************************************************
 * ImgKitPrintEnd() : I                                    *
 *                                                                    *
 *     FHDC    hDC       - ޲÷                   *
 *   ߂lFȂ                                                     *
 **********************************************************************
 * ImgKitPrintStart() : Jn                                  *
 *                                                                    *
 *     FHDC   hDC    - ޲÷                       *
 *                          (0̎DLL޲۸ނ-)         *
 *           LPSTR Title  - ޲۸ޯ                *
 *                          (NULL̎~޲۸ނ̕\Ȃ)       *
 *   ߂lFBOOL     - 0ȊO(TRUE)                               *
 *                   s - 0    (FALSE)                              *
 **********************************************************************
 * ImgKitRectCut() : C[W̐؂                               *
 *                                                                    *
 *     FHANDLE Handle  - Ұް             *
 *           LPSTR  Title   - ޲۸ޯ              *
 *           LPSTR  Message - ޲۸ޯү            *
 *           int    Left    - ؂鍶ʒu(߸)                   *
 *           int    Top     -             (߸)                   *
 *           int    Right   -         E    (߸)                   *
 *           int    Bottom  -             (߸)                   *
 *   ߂lFHANDLE         - V                          *
 **********************************************************************
 * ImgKitRGB() : eqfal̕ύX                                     *
 *                                                                    *
 *     FHANDLE Handle  - Ұް             *
 *           LPSTR  Title   - ޲۸ޯ              *
 *           LPSTR  Message - ޲۸ޯү            *
 *           int    Red     - Ԃ̐Flɉl                      *
 *                            (-255`255)                             *
 *           int    Green   - ΂̐Flɉl                      *
 *                            (-255`255)                             *
 *           int    Bluet   - ̐Flɉl                      *
 *                            (-255`255)                             *
 *   ߂lFBOOL       - 0ȊO(TRUE)                             *
 *                     s - 0    (FALSE)                            *
 **********************************************************************
 * ImgKitRotation() : C[W̉]                                  *
 *                                                                    *
 *     FHANDLE Handle  - Ұް             *
 *           LPSTR Title    - ޲۸ޯ              *
 *           LPSTR Message  - ޲۸ޯү            *
 *           int    Dir     -                                 *
 *                            0 : PWO]                        *
 *                            1 : XO]                        *
 *                            2 : EXO]                        *
 *                            3 : ㉺]                            *
 *                            4 : E]                            *
 *   ߂lFHANDLE         - V                          *
 **********************************************************************
 * ImgKitScan() : [UC^tF[X\ăXLis        *
 *                                                                    *
 *     FHWND         hWnd  - ޳                         *
 *           LPSCAN_IMAGE Image - ǂݎ̎擾pϐ(а)      *
 *   ߂lFHANDLE             - Ұނ                     *
 *           LPSCAN_IMAGE Image - ǂݎ                      *
 **********************************************************************
 * ImgKitScanEasy() : [UC^tF[X\ɃXLis  *
 *                                                                    *
 *     FHWND         hWnd  - ޳                         *
 *           LPSCAN_IMAGE Image - ǂݎ                        *
 *   ߂lFHANDLE             - Ұނ                     *
 *           LPSCAN_IMAGE Image - ǂݎ                      *
 *                                                                    *
 *                                                                    *
 *  LPSCAN_IMAGE \                                               *
 *                                                                    *
 *       Pixeltype : 0-Ql               ( 1ޯ)                *
 *                   1-O[XP[     ( 8ޯ, 4ޯ)         *
 *                   2-PUVOFtJ[ (24ޯ)                *
 *                   3-pbgJ[         ( 8ޯ, 4ޯ)         *
 *                   iӁjPixeltype13ł̎ۂ̓ǂݎ         *
 *                           ޯẮCŰɂĈႤ                *
 *                                                                    *
 *       Left       : ǎ͈͍̈ʒu(C`P)                  *
 *                                                                    *
 *       Top        :           ̈ʒu(C`P)                  *
 *                                                                    *
 *       Right      :           Ëʒu(C`P)                  *
 *                                                                    *
 *       Bottom     :           ̈ʒu(C`P)                  *
 *                                                                    *
 *       Resolution : ǎ𑜓x(ޯ/)                          *
 *                                                                    *
 *       Status     : 0 G[Ȃ                                    *
 *                  : 1 [s                                  *
 *                  : 2 T|[gO@\                                *
 *                  : 3 ݒls                                  *
 *                  : 4 ̑G[                                  *
 **********************************************************************
 * ImgKitScanMulti() : C[Ẅꊇ荞ݑu̎s           *
 *                                                                    *
 *     FHWND  hWnd         - ޳                         *
 *           LPSTR SaveFileName - ۑC[Wt@C              *
 *   ߂lFint                - 擾C[W                  *
 *                                (0 - 擾Ȃ)                      *
 *                                                                    *
 *   SaveFileName : ****.000 Aԍŕۑ                           *
 *                  ****.001                                          *
 *                  ****.002                                          *
 *                                                                   *
 *                                                                   *
 *                                                                   *
 **********************************************************************
 * ImgKitScanSelect() : XLĩhCoI                        *
 *                                                                    *
 *     FHWND hWnd - ޳                                  *
 *   ߂lFBOOL  - 0ȊO(TRUE)                                  *
 *                s - 0    (FALSE)                                 *
 **********************************************************************
 * ImgKitSetGray() : J[C[WO[J[ɕϊ               *
 *                                                                    *
 *     FHANDLE Handle  - Ұް             *
 *           LPSTR Title    - ޲۸ޯ              *
 *           LPSTR Message  - ޲۸ޯү            *
 *   ߂lFHANDLE         - V                          *
 *                                                                    *
 *   ΉC[W                                                 *
 *         SrbgsNZi  PUFJ[j                         *
 *         WrbgsNZiQTUFJ[j                         *
 *       QSrbgsNZitJ[j                             *
 **********************************************************************
 * ImgKitSetToClipBrd() : C[WNbv{[hɃRs[            *
 *                                                                    *
 *     FHWND   hWnd    - ޳                             *
 *           HANDLE Handle  - ߰Ұް                 *
 *   ߂lFBOOL       - 0ȊO(TRUE)                             *
 *                  s    - 0    (FALSE)                            *
 **********************************************************************
 * ImgKitSuperFileSave() : dBC-SUPER`Ńt@Cۑ                *
 *                         ( PC-98 MS-DOSp۸)               *
 *                                                                    *
 *     FLPSTR  FileName - ۑ̧ٖ                             *
 *           HANDLE Handle   - ۑҰް            *
 *           LPSTR  Title    - ޲۸ޯ             *
 *           LPSTR  Message  - ޲۸ޯү           *
 *   ߂lFBOOL        - 0ȊO(TRUE)                            *
 *                     s  - 0    (FALSE)                           *
 *                                                                    *
 *                                                                    *
 *   t@CtH[}bgFϑOXiab|rtodqKij *
 *                                                                    *
 *         'C'(BYTE) :k             +------+                       *
 *         'M'(BYTE) :\             |  C   |                       *
 *          WW(int)  :oCg       +------+                       *
 *          HH(int)  :cC       |  M   |                       *
 *          122oCg̃_~[          +-------------+                *
 *          SIZE(int):koCg     |      WW     |                *
 *          BITS     :f[^           +-------------+                *
 *          SIZE(int):koCg     |      HH     |                *
 *          BITS     :f[^           +-----------------//-+         *
 *                 E                  |    а(122޲)   |         *
 *                 E                  +-----------------//-+         *
 *                 E                  |    SIZE     |                *
 *                                     +-------------------//---+     *
 *                                     |    BITS(SIZE޲)      |     *
 *                                     +-------------------//---+     *
 *                                     |    SIZE     |                *
 *                                     +-------------------//---+     *
 *                                     |    BITS(SIZE޲)      |     *
 *                                     +-------------------//---+     *
 *          BITSk                               E                 *
 *          摜,۰ٺ,                 E                 *
 *            byte   byte(9d)  byte                E                 *
 *                                                                    *
 *          j  AAABBCDDDDD  A'9d''3'BBCD'9d''5'                  *
 *                 (11޲)          (9޲)                          *
 *                                                                    *
 *          9dh - 摜k                                        *
 *          95h - 摜ްkނƓIɕύX              *
 *                                                                    *
 *   ΉC[W                                                 *
 *       PrbgsNZiQFj                                     *
 **********************************************************************
 * ImgKitSystemPalette() : ݂̃VXeiRs[^j           *
 *                         pbg擾                           *
 *                                                                    *
 *     ߂l Fint -   2 :         QFi  PrbgsNZj        *
 *                     16 :       PUFi  SrbgsNZj        *
 *                    256 :     QTUFi  WrbgsNZj        *
 *                      0 : PUVOFiQSrbgsNZj        *
 **********************************************************************
 * ImgKitTiffFileLoad() : shee`̃t@ČĂяo            *
 *                                                                    *
 *     FLPSTR FileName - Ăяo̧ٖ                          *
 *           LPSTR Title    - ޲۸ޯ              *
 *           LPSTR Message  - ޲۸ޯү            *
 *           int   Page     - Ăяo߰ޔԍ(0n܂ԍ)      *
 *   ߂lFHANDLE         - Ұނ                         *
 *                                                                    *
 * ImgKitFileLoad()ł̓ǂݍ݂ł͕̃C[W鎞A           *
 * ŏ̃y[WiOy[Wj̓ǂݍ݂s                       *
 **********************************************************************
 * ImgKitTiffFileSave() : shee`Ńt@Cۑ                  *
 *                                                                    *
 *     FLPSTR  FileName - ۑ̧ٖ                             *
 *           HANDLE Handle   - ۑҰް            *
 *           LPSTR  Title    - ޲۸ޯ             *
 *           LPSTR  Message  - ޲۸ޯү           *
 *           int    Type     - k׸                               *
 *                             Type : 0 񈳏k                        *
 *                             Type : 1 CCITTRLE                      *
 *                             Type : 2 GROUP3-1D                     *
 *                             Type : 3 GROUP3-2D                     *
 *                             Type : 4 GROUP4                        *
 *                             Type : 5 PACKBITS                      *
 *                             Type : 6 LZW                           *
 *   ߂lFBOOL        - 0ȊO(TRUE)                            *
 *                  s     - 0    (FALSE)                           *
 **********************************************************************
 *   ɕ\_CAO{bNXɂ                       *
 *                                                                    *
 *   LPSTR Title, LPSTR Message ɂ                              *
 *   +---------------------+                                          *
 *   |        Title        |      ̒͂QSoCg            *
 *   +---------------------+      ȉɂ                          *
 *   |       Message       |                                          *
 *   |  +----------+----+  |                                          *
 *   |  |     70%  |    |  |     Title, Message Ƃ NULL̂Ƃ   *
 *   |  +----------+----+  |     ̃_CAO\A           *
 *   |     +--------+      |     vACR\             *
 *   |     | Cancel |      |                                          *
 *   |     +--------+      |                                          *
 *   +---------------------+                                          *
 **********************************************************************/

typedef struct {
	short	Pixeltype;				// 0: 1:ʐ^(8ޯĸڰ) 2:װʐ^(24ޯ) 3:256װ(8ޯ)
	float	Left;					// ̈ʒu(C`P)
	float	Top;					// ̈ʒu(C`P)
	float	Right;					// Ëʒu(C`P)
	float	Bottom;					// ̈ʒu(C`P)
	float	Resolution;				// DPI
	int		Status;					// G[(0: 1:ؕs 2:߰ĊO@\ 3:ݒl̕s 4:̑װ
} SCAN_IMAGE;
typedef SCAN_IMAGE FAR* LPSCAN_IMAGE;

typedef struct {
	long			Width;			// ̃sNZ
	long			Height;			// c̃sNZ
	int				Pixeltype;		// sNZ^Cv
	long			WidthByte;		// ̃oCg
	unsigned long	ImageSize;		// C[WTCY
} IMAGE_INFO;
typedef IMAGE_INFO FAR* LPIMAGE_INFO;

typedef struct {
	short			Type;			// t@C^Cv
	long			Width;			// ̃sNZ
	long			Height;			// c̃sNZ
	short			BitCount;		// sNZ^rbg
	long			WidthByte;		// ̃oCg
	unsigned long	ImageSize;		// C[WTCY
} FILE_INFO;
typedef FILE_INFO FAR* LPFILE_INFO;


		// IMAGE_INFOPixeltype
#define IK_MONO_INFO				0	// PrbgiQlj
#define IK_COLOR16_INFO				1	// SrbgiPUFJ|j
#define IK_GRAY16_INFO				2	// SrbgiPUKO|)
#define IK_COLOR256_INFO			3	// WrbgiQTUFJ|j
#define IK_GRAY256_INFO				4	// WrbgiQTUKO|j
#define IK_COLORFULL_INFO			5	// QSrbgitJ|j

		// ]
#define IK_ROTATE_180				0	// PWO
#define IK_ROTATE_L90				1	// XO
#define IK_ROTATE_R90				2	// EXO
#define IK_ROTATE_UD				3	// ㉺]
#define IK_ROTATE_RL				4	// E]

		// tB^
#define IK_LOPASS_HV_FILTER			0	// ۰̨߽(Ɛ̏)
#define IK_LOPASS_H_FILTER			1	//          (̏)      
#define IK_LOPASS_V_FILTER			2	//          (̏)      
#define IK_ROBERT_FILTER			3	// ް̨                      
#define IK_RAPRA_FILTER				4	// ׼̨                    

		// t@C [hEZ[u
#define IK_LOAD_FILE				0	// ۰
#define IK_LOAD_JPEG_FILE			1	// ۰(JPEG ڰ)
#define IK_LOAD_GIF_FILE			2	// ۰(GIF߰ގw)
#define IK_LOAD_TIFF_FILE			3	// ۰(TIFF߰ގw)
#define IK_SAVE_BMP_FILE			4	// (BMP)
#define IK_SAVE_BMP_RLE_FILE		5	// (BMP RLE)
#define IK_SAVE_JPEG_FILE			6	// (JPEG)
#define IK_SAVE_JPEGGRAY_FILE		7	// (JPEG ڰ)
#define IK_SAVE_GIF_FILE			8	// (GIF)
#define IK_SAVE_GIF_INTER_FILE		9	// (GIF ڰ)
#define IK_SAVE_GIFT_FILE			10	// (GIF )
#define IK_SAVE_GIFT_INTER_FILE		11	// (GIF ڰ )
#define IK_SAVE_TIFF_NONE_FILE		12	// (TIFF 񈳏k)
#define IK_SAVE_TIFF_RLE_FILE		13	// (TIFF CCITTRLE)
#define IK_SAVE_TIFF_FAX31D_FILE	14	// (TIFF FAX3 1D)
#define IK_SAVE_TIFF_FAX32D_FILE	15	// (TIFF FAX3 2D)
#define IK_SAVE_TIFF_FAX4_FILE		16	// (TIFF FAX4)
#define IK_SAVE_TIFF_PACKBITS_FILE	17	// (TIFF PACKBITS)
#define IK_SAVE_TIFF_LZW_FILE		18	// (TIFF LZW)
#define IK_SAVE_DBC_FILE			19	// (dBC-SUPER)

		// \
#define IK_SCALE_DISP				0	// 
#define IK_REAL_DISP				1	// 
#define IK_STRETCH_DISP				2	// گ
#define IK_REAL2_DISP				3	// (۰ްȂ)
#define IK_SCROLL_LT_DISP			4	// ۰()
#define IK_SCROLL_T_DISP			5	// ۰()
#define IK_SCROLL_RT_DISP			6	// ۰(E)
#define IK_SCROLL_R_DISP			7	// ۰(E)
#define IK_SCROLL_RB_DISP			8	// ۰(E)
#define IK_SCROLL_B_DISP			9	// ۰()
#define IK_SCROLL_LB_DISP			10	// ۰()
#define IK_SCROLL_L_DISP			11	// ۰()

		// 
#define IK_START_PRINT				0	// Jn
#define IK_GO_PRINT					1	// 
#define IK_END_PRINT				2	// s

		// ҏW
#define IK_ROTATION_EDIT			0	// ]
#define IK_BIT24TO8_EDIT			1	// ٶװ256F
#define IK_BIT8TO4_EDIT				2	// 25616F
#define IK_SETGRAY_EDIT				3	// ڰٕϊ
#define IK_IMAGESIZE_EDIT			4	// Ұ޻ނ̕ύX
#define IK_EMBOSS_EDIT				5	// 菈
#define IK_COLORREVERSE_EDIT		6	// F̔]
#define IK_COLOR24AND8_EDIT			7	// ٶװ256F(256ڰ)̍
#define IK_MOSAIC_EDIT				8	// ӻ޲
#define IK_FILTER_EDIT				9	// ̨
#define IK_CUT_EDIT					10	// ؂菈
#define IK_RECTCUT_EDIT				11	// `؂菈
#define IK_SET_CLIP_EDIT			12	// دްނֺ߰
#define IK_GET_CLIP_EDIT			13	// دްނ߰
#define IK_BRIGHT_EDIT				14	// Px
#define IK_RGB_EDIT					15	// RGBF
#define IK_COPYIMAGE				16	// Ұނ̺߰
#define IK_CONVCOLOR				17	// Ұނ̐FύX
#define IK_ADDIMAGE					18	// Ұނ̍

		// XL
#define IK_SELECT_SCAN				0	// ͑ȗI
#define IK_GO_SCAN					1	// Ŏs
#define IK_USER_SCAN				2	// Ŏs(ȈՎ捞)
#define IK_MULTI_SCAN				3	// Ұގ荞

		// sNZ^Cv(œǍ)
#define IK_MONO_SCAN_PIXEL			0	// 
#define IK_MONO8_SCAN_PIXEL			1	// ʐ^(8ޯĸڰ)
#define IK_COLOR24_SCAN_PIXEL		2	// װʐ^(24ޯ)
#define IK_COLOR8_SCAN_PIXEL		3	// 256װ(8ޯ)

		// XChVE
#define IK_START_SLIDE				0	// ײ޼̊Jn
#define IK_NEXT_SLIDE				1	// 
#define IK_PREV_SLIDE				2	// ߂
#define IK_END_SLIDE				3	// ײ޼̏I
#define IK_TOP_SLIDE				4	// 擪
#define IK_BOTTOM_SLIDE				5	// Ō
#define IK_PAUSE_SLIDE				6	// ~
#define IK_RESUME_SLIDE				7	// ĊJ

		// XCh\@
#define IK_SCROLL_NM_SLIDE			0	// ʏ
#define IK_SCROLL_RL_SLIDE			1	// E
#define IK_SCROLL_LR_SLIDE			2	// E
#define IK_SCROLL_UD_SLIDE			3	// と
#define IK_SCROLL_DU_SLIDE			4	// ど


#ifdef __cplusplus
extern "C" {            /* Assume C declarations for C++ */
#endif

// IMGCOM.DLL IMGCOM3.DLL
DWORD  IMAGEKIT_API ImgKitMemSize(HANDLE Handle);
BOOL   IMAGEKIT_API ImgKitMemFree(HANDLE Handle);
int    IMAGEKIT_API ImgKitSystemPalette(void);

// IMGSCAN.DLL IMGSCAN3.DLL
BOOL   IMAGEKIT_API ImgKitScanSelect(HWND hWnd);
HANDLE IMAGEKIT_API ImgKitScan(HWND hWnd, LPSCAN_IMAGE Image);
HANDLE IMAGEKIT_API ImgKitScanEasy(HWND hWnd, LPSCAN_IMAGE Image);
int    IMAGEKIT_API ImgKitScanMulti(HWND hWnd, LPSTR SaveFileName);

// IMGETC.DLL IMGETC3.DLL
HANDLE IMAGEKIT_API ImgKitRotation(HANDLE Handle, LPSTR Title, LPSTR Message, int Dir);
HANDLE IMAGEKIT_API ImgKitBit24To8(HANDLE Handle, LPSTR Title, LPSTR Message);
HANDLE IMAGEKIT_API ImgKitBit8To4(HANDLE Handle, LPSTR Title, LPSTR Message);
HANDLE IMAGEKIT_API ImgKitSetGray(HANDLE Handle, LPSTR Title, LPSTR Message);
HANDLE IMAGEKIT_API ImgKitImageSize(HANDLE Handle, LPSTR Title, LPSTR Message, int Width, int Height);
BOOL   IMAGEKIT_API ImgKitImageInfo(HANDLE Handle, LPIMAGE_INFO ImageInfo);
BOOL   IMAGEKIT_API ImgKitEmboss(HANDLE Handle, LPSTR Title, LPSTR Message);
BOOL   IMAGEKIT_API ImgKitColorReverse(HANDLE Handle, LPSTR Title, LPSTR Message);
HANDLE IMAGEKIT_API ImgKitColor24And8(HANDLE Handle24, HANDLE Handle8, LPSTR Title, LPSTR Message);
BOOL   IMAGEKIT_API ImgKitMosaic(HANDLE Handle, LPSTR Title, LPSTR Message, int Rect);
BOOL   IMAGEKIT_API ImgKitFilter(HANDLE Handle, LPSTR Title, LPSTR Message, int Proc);
HANDLE IMAGEKIT_API ImgKitCopy(HANDLE Handle, LPSTR Title, LPSTR Message);

// IMGFILE.DLL IMGFILE3.DLL
HANDLE IMAGEKIT_API ImgKitFileLoad(LPSTR FileName, LPSTR Title, LPSTR Message);
HANDLE IMAGEKIT_API ImgKitJpegFileLoad(LPSTR FileName, LPSTR Title, LPSTR Message, int JpgCol);
HANDLE IMAGEKIT_API ImgKitGifFileLoad(LPSTR FileName, LPSTR Title, LPSTR Message, int Page);
BOOL   IMAGEKIT_API ImgKitBmpFileSave(LPSTR FileName, HANDLE Handle, LPSTR Title, LPSTR Message, BOOL Comp);
BOOL   IMAGEKIT_API ImgKitJpegFileSave(LPSTR FileName, HANDLE Handle, LPSTR Title, LPSTR Message, int Quality, int JpgCol);
BOOL   IMAGEKIT_API ImgKitSuperFileSave(LPSTR FileName, HANDLE Handle, LPSTR Title, LPSTR Message);
BOOL   IMAGEKIT_API ImgKitGifFileSave(LPSTR FileName, HANDLE Handle, LPSTR Title, LPSTR Message);
BOOL   IMAGEKIT_API ImgKitGifInterFileSave(LPSTR FileName, HANDLE Handle, LPSTR Title, LPSTR Message);

// IMGDSP.DLL IMGDSP3.DLL
BOOL   IMAGEKIT_API ImgKitDisplay(HWND hWnd, HANDLE handle, BOOL Stretch);
BOOL   IMAGEKIT_API ImgKitDisplayHdc(HDC hDC, HANDLE handle, int Width, int Height, BOOL Stretch);
BOOL   IMAGEKIT_API ImgKitPrintStart(HDC hDC, LPSTR Title);
BOOL   IMAGEKIT_API ImgKitPrint(HWND hWnd, HDC hDC, HANDLE handle, LPRECT PrintRect, BOOL Frame);
void   IMAGEKIT_API ImgKitPrintEnd(HDC hDC);

// IMGCUT.DLL IMGCUT3.DLL
BOOL   IMAGEKIT_API ImgKitCut(HANDLE handle, LPSTR aTitle, LPSTR aMessage);

HANDLE IMAGEKIT_API ImgKitTiffFileLoad(LPSTR FileName, LPSTR Title, LPSTR Message, int Page);
BOOL   IMAGEKIT_API ImgKitTiffFileSave(LPSTR FileName, HANDLE Handle, LPSTR Title, LPSTR Message, int Type);
BOOL   IMAGEKIT_API ImgKitGifTrFileSave(LPSTR FileName, HANDLE Handle, WORD Red, WORD Green, WORD Blue, LPSTR Title, LPSTR Message);
BOOL   IMAGEKIT_API ImgKitGifInterTrFileSave(LPSTR FileName, HANDLE Handle, WORD Red, WORD Green, WORD Blue, LPSTR Title, LPSTR Message);
HANDLE IMAGEKIT_API ImgKitRectCut(HANDLE Handle, LPSTR Title, LPSTR Message, int Left, int Top, int Right, int Bottom);
HANDLE IMAGEKIT_API ImgKitGetFromClipBrd(HWND hWnd);
BOOL   IMAGEKIT_API ImgKitSetToClipBrd(HWND hWnd, HANDLE Handle);
BOOL   IMAGEKIT_API ImgKitBright(HANDLE Handle, LPSTR Title, LPSTR Message, double Bright);
BOOL   IMAGEKIT_API ImgKitRGB(HANDLE Handle, LPSTR Title, LPSTR Message, int Red, int Green, int Blue);

BOOL   IMAGEKIT_API ImgKitFileType(LPSTR FileName, LPFILE_INFO FileType);
HANDLE IMAGEKIT_API ImgKitImageAdd(HANDLE Handle1, HANDLE Handle2, int x, int y, int Red, int Green, int Blue, LPSTR Title, LPSTR Message);
HANDLE IMAGEKIT_API ImgKitConvertColor(HANDLE Handle, int Pixeltype, BOOL FixedPal, BOOL Dither, LPSTR Title, LPSTR Message);
BOOL   IMAGEKIT_API ImgKitDisplayRGB(HWND hWnd, HANDLE Handle, BOOL Stretch, int Red, int Green, int Blue, BOOL Frame);
BOOL   IMAGEKIT_API ImgKitDisplayHdcRGB(HDC hDC, HANDLE Handle, int Width, int Height, BOOL Stretch, int Red, int Green, int Blue, BOOL Frame);
BOOL   IMAGEKIT_API ImgKitDisplayHdcXY(HDC hDC, HANDLE Handle, int Xstart, int Ystart);
BOOL   IMAGEKIT_API ImgKitDisplayXY(HWND hWnd, HANDLE Handle, int Xstart, int Ystart);


typedef DWORD  (FAR_PASCAL *PROCIMGKITMEMSIZE)(HANDLE Handle);
typedef BOOL   (FAR_PASCAL *PROCIMGKITMEMFREE)(HANDLE Handle);
typedef int    (FAR_PASCAL *PROCIMGKITSYSTEMPALETTE)(void);

typedef BOOL   (FAR_PASCAL *PROCIMGKITSCANSELECT)(HWND hWnd);
typedef HANDLE (FAR_PASCAL *PROCIMGKITSCAN)(HWND hWnd, LPSCAN_IMAGE Image);
typedef HANDLE (FAR_PASCAL *PROCIMGKITSCANEASY)(HWND hWnd, LPSCAN_IMAGE Image);
typedef int    (FAR_PASCAL *PROCIMGKITSCANMULTI)(HWND hWnd, LPSTR SaveFileName);

typedef HANDLE (FAR_PASCAL *PROCIMGKITROTATION)(HANDLE Handle, LPSTR Title, LPSTR Message, int Dir);
typedef HANDLE (FAR_PASCAL *PROCIMGKITBIT24TO8)(HANDLE Handle, LPSTR Title, LPSTR Message);
typedef HANDLE (FAR_PASCAL *PROCIMGKITBIT8TO4)(HANDLE Handle, LPSTR Title, LPSTR Message);
typedef HANDLE (FAR_PASCAL *PROCIMGKITSETGRAY)(HANDLE Handle, LPSTR Title, LPSTR Message);
typedef HANDLE (FAR_PASCAL *PROCIMGKITIMAGESIZE)(HANDLE Handle, LPSTR Title, LPSTR Message, int Width, int Height);
typedef BOOL   (FAR_PASCAL *PROCIMGKITIMAGEINFO)(HANDLE Handle, LPIMAGE_INFO ImageInfo);
typedef BOOL   (FAR_PASCAL *PROCIMGKITEMBOSS)(HANDLE Handle, LPSTR Title, LPSTR Message);
typedef BOOL   (FAR_PASCAL *PROCIMGKITCOLORREVERSE)(HANDLE Handle, LPSTR Title, LPSTR Message);
typedef HANDLE (FAR_PASCAL *PROCIMGKITCOLOR24AND8)(HANDLE Handle24, HANDLE Handle8, LPSTR Title, LPSTR Message);
typedef BOOL   (FAR_PASCAL *PROCIMGKITMOSAIC)(HANDLE Handle, LPSTR Title, LPSTR Message, int Rect);
typedef BOOL   (FAR_PASCAL *PROCIMGKITFILTER)(HANDLE Handle, LPSTR Title, LPSTR Message, int Proc);
typedef HANDLE (FAR_PASCAL *PROCIMGKITCOPY)(HANDLE Handle, LPSTR Title, LPSTR Message);

typedef HANDLE (FAR_PASCAL *PROCIMGKITFILELOAD)(LPSTR FileName, LPSTR Title, LPSTR Message);
typedef HANDLE (FAR_PASCAL *PROCIMGKITJPEGFILELOAD)(LPSTR FileName, LPSTR Title, LPSTR Message, int JpgCol);
typedef BOOL   (FAR_PASCAL *PROCIMGKITBMPFILESAVE)(LPSTR FileName, HANDLE Handle, LPSTR Title, LPSTR Message, BOOL Comp);
typedef BOOL   (FAR_PASCAL *PROCIMGKITJPEGFILESAVE)(LPSTR FileName, HANDLE Handle, LPSTR Title, LPSTR Message, int Quality, int JpgCol);
typedef BOOL   (FAR_PASCAL *PROCIMGKITSUPERFILESAVE)(LPSTR FileName, HANDLE Handle, LPSTR Title, LPSTR Message);
typedef BOOL   (FAR_PASCAL *PROCIMGKITGIFINTERFILESAVE)(LPSTR FileName, HANDLE Handle, LPSTR Title, LPSTR Message);
typedef HANDLE (FAR_PASCAL *PROCIMGKITGIFFILELOAD)(LPSTR FileName, LPSTR Title, LPSTR Message, int Page);
typedef BOOL   (FAR_PASCAL *PROCIMGKITGIFFILESAVE)(LPSTR FileName, HANDLE Handle, LPSTR Title, LPSTR Message);

typedef BOOL   (FAR_PASCAL *PROCIMGKITDISPLAY)(HWND hWnd, HANDLE handle, BOOL Stretch);
typedef BOOL   (FAR_PASCAL *PROCIMGKITDISPLAYHDC)(HDC hDC, HANDLE handle, int Width, int Height, BOOL Stretch);
typedef BOOL   (FAR_PASCAL *PROCIMGKITPRINTSTART)(HDC hDC, LPSTR Title);
typedef BOOL   (FAR_PASCAL *PROCIMGKITPRINT)(HWND hWnd, HDC hDC, HANDLE handle, LPRECT PrintRect, BOOL Frame);
typedef void   (FAR_PASCAL *PROCIMGKITPRINTEND)(HDC hDC);

typedef BOOL   (FAR_PASCAL *PROCIMGKITCUT)(HANDLE handle, LPSTR aTitle, LPSTR aMessage);

typedef HANDLE (FAR_PASCAL *PROCIMGKITTIFFFILELOAD)(LPSTR FileName, LPSTR Title, LPSTR Message, int Page);
typedef BOOL   (FAR_PASCAL *PROCIMGKITTIFFFILESAVE)(LPSTR FileName, HANDLE Handle, LPSTR Title, LPSTR Message, int Type);
typedef BOOL   (FAR_PASCAL *PROCIMGKITGIFTRFILESAVE)(LPSTR FileName, HANDLE Handle, WORD Red, WORD Green, WORD Blue, LPSTR Title, LPSTR Message);
typedef BOOL   (FAR_PASCAL *PROCIMGKITGIFINTERTRFILESAVE)(LPSTR FileName, HANDLE Handle, WORD Red, WORD Green, WORD Blue, LPSTR Title, LPSTR Message);
typedef HANDLE (FAR_PASCAL *PROCIMGKITRECTCUT)(HANDLE Handle, LPSTR aTitle, LPSTR aMessage, int Left, int Top, int Right, int Bottom);
typedef HANDLE (FAR_PASCAL *PROCIMGKITGETFROMCLIPBRD)(HWND hWnd);
typedef BOOL   (FAR_PASCAL *PROCIMGKITSETTOCLIPBRD)(HWND hWnd, HANDLE Handle);
typedef BOOL   (FAR_PASCAL *PROCIMGKITBRIGHT)(HANDLE Handle, LPSTR Title, LPSTR Message, double Bright);
typedef BOOL   (FAR_PASCAL *PROCIMGKITRGB)(HANDLE Handle, LPSTR Title, LPSTR Message, int Red, int Green, int Blue);

typedef HANDLE (FAR_PASCAL *PROCIMGKITFILETYPE)(LPSTR FileName, LPFILE_INFO FileType);
typedef HANDLE (FAR_PASCAL *PROCIMGKITIMAGEADD)(HANDLE Handle1, HANDLE Handle2, int x, int y, int Red, int Green, int Blue, LPSTR Title, LPSTR Message);
typedef HANDLE (FAR_PASCAL *PROCIMGKITCONVERTCOLOR)(HANDLE Handle, int Color, BOOL Palette, BOOL Dither, LPSTR Title, LPSTR Message);
typedef HANDLE (FAR_PASCAL *PROCIMGKITDISPLAYRGB)(HWND hWnd, HANDLE Handle, BOOL Stretch, int Red, int Green, int Blue, BOOL Frame);
typedef HANDLE (FAR_PASCAL *PROCIMGKITDISPLAYHDCRGB)(HDC hDC, HANDLE Handle, int Width, int Height, BOOL Stretch, int Red, int Green, int Blue, BOOL Frame);
typedef HANDLE (FAR_PASCAL *PROCIMGKITDISPLAYHDCXY)(HDC hDC, HANDLE Handle, int Xstart, int Ystart);
typedef HANDLE (FAR_PASCAL *PROCIMGKITDISPLAYXY)(HWND hWnd, HANDLE Handle, int Xstart, int Ystart);

#ifdef  __cplusplus
}
#endif

#endif			// IMAGEKIT_INCLUDE
