//---------------------------------------------------------------------------
#include <vcl\vcl.h>
#include <vcl\registry.hpp>
#pragma hdrstop

#include "Wall.h"
#include "MdiView.h"
//---------------------------------------------------------------------------
#pragma resource "*.dfm"
TWallForm *WallForm;
//---------------------------------------------------------------------------
__fastcall TWallForm::TWallForm(TComponent* Owner)
	: TForm(Owner)
{
}
//---------------------------------------------------------------------------
void __fastcall TWallForm::FormCreate(TObject *Sender)
{
	ClientWidth = Screen->Width / 4;
    ClientHeight = Screen->Height / 4 + 104;

    Panel1->Width = Screen->Width / 4;
    Panel1->Height = Screen->Height / 4;

    WallBitmap = new Graphics::TBitmap;

	WallBitmap->Width = ViewForm->Image1->Width / 4;
    WallBitmap->Height = ViewForm->Image1->Height / 4;

    WallBitmap->Canvas->StretchDraw(Rect(0, 0, WallBitmap->Width - 1,
    WallBitmap->Height - 1), ViewForm->Image1->Picture->Bitmap);
}
//---------------------------------------------------------------------------
void __fastcall TWallForm::FormClose(TObject *Sender, TCloseAction &Action)
{
	delete WallBitmap;
}
//---------------------------------------------------------------------------
void __fastcall TWallForm::RadioGroup1Click(TObject *Sender)
{
	int	lx, ly, rx, ry;

    Image3->Canvas->Brush->Color = clBtnFace;
    Image3->Canvas->Rectangle(0, 0, Image3->Width - 1, Image3->Height - 1);

    if (RadioGroup1->ItemIndex == 0) {
		lx = (Image3->Width - WallBitmap->Width) / 2;
    	ly = (Image3->Height - WallBitmap->Height) / 2;
    	rx = lx + WallBitmap->Width - 1;
    	ry = ly + WallBitmap->Height - 1;
    	Image3->Canvas->StretchDraw(Rect(lx, ly, rx, ry), WallBitmap);
    }
    else if (RadioGroup1->ItemIndex == 1) {
    	for (ly = 0; ly < Image3->Height; ly += WallBitmap->Height) {
        	ry = ly + WallBitmap->Height - 1;
            for (lx = 0; lx < Image3->Width; lx += WallBitmap->Width) {
            	rx = lx + WallBitmap->Width - 1;
    			Image3->Canvas->StretchDraw(Rect(lx, ly, rx, ry), WallBitmap);
            }
        }
    }

}
//---------------------------------------------------------------------------
void __fastcall TWallForm::FormShow(TObject *Sender)
{
	RadioGroup1Click(Sender);
}
//---------------------------------------------------------------------------
